"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isSemiperfect = void 0;
const enhancedNumber_1 = require("../classes/enhancedNumber");
const isAbundant_1 = require("./isAbundant");
const isPerfect_1 = require("./isPerfect");
const isPowerOf2_1 = require("./isPowerOf2");
const isPractical_1 = require("./isPractical");
const semiperfectTest_1 = require("./semiperfectTest");
const getAliquotSum_1 = require("./getAliquotSum");
function isSemiperfect(n) {
	n = new enhancedNumber_1.EnhancedNumber(n);
	if (n._isSemiperfect) {
		return n.isSemiperfect;
	}
	if (n.number <= 1) {
		n.isSemiperfect = false;
		return n.isSemiperfect;
	}
	if ((0, getAliquotSum_1.getAliquotSum)(n) === n.number) {
		n.isSemiperfect = true;
		return n.isSemiperfect;
	}
	if ((0, isPractical_1.isPractical)(n) && !(0, isPowerOf2_1.isPowerOf2)(n)) {
		n.isSemiperfect = true;
		return n.isSemiperfect;
	}
	if ((0, isPerfect_1.isPerfect)(n) || (0, isAbundant_1.isAbundant)(n)) {
		console.warn(
			"This is likely to lag significantly (3b302489-dbe4-505c-989e-d9b122eb2340)"
		);
		n.isSemiperfect = (0, semiperfectTest_1.semiperfectTest)(n);
		return n.isSemiperfect;
	}
	n.isSemiperfect = false;
	return n.isSemiperfect;
}
exports.isSemiperfect = isSemiperfect;
//# sourceMappingURL=isSemiperfect.js.map
