"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isTetrahedral = void 0;
const enhancedNumber_1 = require("../classes/enhancedNumber");
const getTetrahedral_1 = require("./getTetrahedral");
const positiveOrNegativeSequence_1 = require("./positiveOrNegativeSequence");
function isTetrahedral(inputN) {
	const n = new enhancedNumber_1.EnhancedNumber(inputN);
	if (n._isTetrahedral) {
		return n.isTetrahedral;
	}
	let c = 0;
	while (true) {
		let nth = (0, getTetrahedral_1.getTetrahedral)(c);
		c = (0, positiveOrNegativeSequence_1.positiveOrNegativeSequence)(
			n.number,
			nth,
			c
		);
		if (c === true || c === false) {
			n.isTetrahedral = c;
			return n.isTetrahedral;
		}
	}
}
exports.isTetrahedral = isTetrahedral;
//# sourceMappingURL=isTetrahedral.js.map
